const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const wallet_transactions = sequelize.define(
    'wallet_transactions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

transaction_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"royalty_accrual",


"adjustment",


"withdrawal_request",


"withdrawal_paid",


"withdrawal_failed",


"refund",


"fee"

        ],

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency: {
        type: DataTypes.TEXT,
      
      

      },

posted_at: {
        type: DataTypes.DATE,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

external_reference: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  wallet_transactions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.wallet_transactions.belongsTo(db.wallets, {
      as: 'wallet',
      foreignKey: {
        name: 'walletId',
      },
      constraints: false,
    });

    db.wallet_transactions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.wallet_transactions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.wallet_transactions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return wallet_transactions;
};


